#include <owl\applicat.h>
#include <owl\window.h>
#include <owl\framewin.h>
#include <owl\edit.h>
#include <owl\listbox.h>
#include <string.h>
#include <cstring.h>
#include <windows.h>
#include "pr76_1.rc"
const int UPDATE_WINDOW1=101;
const int UPDATE_WINDOW3=103;


//  .

class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};

class TNewList : public TListBox
{
	public:
	   TNewList(TWindow *parent,int Id,int x,int y,int w,int h, TModule* module = 0):                                                  TListBox(parent,Id,x,y,w,h,0){};
	protected:
			void EvRButtonDown (UINT modKeys,TPoint &point);
			void EvRButtonUp (UINT modKeys,TPoint &point);
			DECLARE_RESPONSE_TABLE(TNewList);
};

DEFINE_RESPONSE_TABLE1(TNewList, TListBox)
	 EV_WM_RBUTTONDOWN,
	 EV_WM_RBUTTONUP,
END_RESPONSE_TABLE;
//   .
class TWndw : public  TFrameWindow
{
  public:
		 TWndw ( const char  *title);
  protected:
			BOOL fl;
			char s[30];
			int n,p;
			TNewList *listBox1;
			TNewList *listBox2;
			void SetupWindow();
			void EvRButtonUp(UINT,TPoint &point);
			void EvMouseMove(UINT,TPoint &point);
			void Vibor1();
			void Vibor2();
			void Otp1();
			void Otp2();
			DECLARE_RESPONSE_TABLE(TWndw);

};
 DEFINE_RESPONSE_TABLE1(TWndw, TFrameWindow)
	EV_WM_RBUTTONUP,
	EV_WM_MOUSEMOVE,
	EV_CHILD_NOTIFY(ID_LISTBOX1,UPDATE_WINDOW1,Vibor1),
	EV_CHILD_NOTIFY(ID_LISTBOX2,UPDATE_WINDOW1,Vibor2),
	EV_CHILD_NOTIFY(ID_LISTBOX1,UPDATE_WINDOW3,Otp1),
	EV_CHILD_NOTIFY(ID_LISTBOX2,UPDATE_WINDOW3,Otp2),
END_RESPONSE_TABLE;


//    .
TWndw::TWndw( const char  *title):
			 TFrameWindow (0, title),TWindow(0,title)
{ //      
  //  .
  EnableKBHandler();
  AssignMenu(MENU_1);
  //     .
  Attr.X = 100;
  Attr.Y = 60;
  Attr.W = 600;
  Attr.H = 550;
  //     .
  new TStatic (this, -1, "List Box1:",30, 14, 80, 36, 10 );
  listBox1 = new TNewList (this, ID_LISTBOX1,  30, 45,150, 150 );
  new TStatic (this, -1, "List Box2:",250, 14, 80, 36, 10 );
  listBox2 = new TNewList (this, ID_LISTBOX2,  250, 45,150, 150 );
}


void TWndw::SetupWindow()
{
  TFrameWindow::SetupWindow();
  //     .
  listBox1->AddString(" ");
  listBox1->AddString("  ");
  listBox1->AddString(" ");
  listBox1->AddString("  ");
  listBox2->AddString("");
  listBox2->AddString("");
  listBox2->AddString("");
  listBox2->AddString("");
  listBox2->AddString("");
  listBox1->SetSelIndex(-1);
  listBox2->SetSelIndex(-1);
  fl=false;  //   ""
  n=0;
  p=-1;
}

void TNewList::EvRButtonDown(UINT modKeys,TPoint &point)
{
  Parent->SendNotification(Attr.Id,UPDATE_WINDOW1,HWindow);
 }


void TNewList::EvRButtonUp(UINT modKeys,TPoint &point)
{
 Parent->SendNotification(Attr.Id,UPDATE_WINDOW3,HWindow);
 }

void TWndw::Vibor1()
{
	p=listBox1->GetSelIndex();
	if (p!=(-1)) //    
		{listBox1->GetSelString(s,sizeof(s));
		 fl=true;
		 n=1; //"   "
		  }
		else   MessageBox("     !","",MB_OK|MB_ICONEXCLAMATION);
}

void TWndw::Vibor2()
{
	p=listBox2->GetSelIndex();
	if (p!=(-1)) //    
		{ listBox2->GetSelString(s,sizeof(s));
		  fl=true;
		  n=2; //"   "
		 }
  else  MessageBox("     !","",MB_OK|MB_ICONEXCLAMATION);

}

void TWndw::EvMouseMove(UINT ,TPoint &point)
{    const char*cursor;
	  HINSTANCE instance;
	  HCURSOR hCursor;
	if (fl==true)     // - "",   
	 { instance=NULL;
	  cursor=IDC_WAIT;
	  hCursor=LoadCursor(instance,cursor);
	  SetClassWord(GCW_HCURSOR,(WORD) hCursor);   }
}



void TWndw::Otp1()
{ //  ""   
  if ((n==2)&&(fl==true))
	 { listBox1->AddString(s);
		listBox2->DeleteString(p); }
  fl=false;
  n=0;
  //   
  const char*cursor;
  HINSTANCE instance;
  HCURSOR hCursor;
  instance=NULL;
  cursor=IDC_ARROW;
  hCursor=LoadCursor(instance,cursor);
  SetClassWord(GCW_HCURSOR,(WORD) hCursor);
}
void TWndw::Otp2()
{ //  ""   
  if ((n==1)&&(fl==true))
	  {listBox2->AddString(s);
		listBox1->DeleteString(p); }
  fl=false;
  n=0;
  //   
  const char*cursor;
  HINSTANCE instance;
  HCURSOR hCursor;
  instance=NULL;
  cursor=IDC_ARROW;
  hCursor=LoadCursor(instance,cursor);
  SetClassWord(GCW_HCURSOR,(WORD) hCursor);
}

void TWndw::EvRButtonUp(UINT,TPoint &point)
{  // " "  
  	if (fl==true)
 	{fl=false;
	       n=0;
	       p=0;
	       const char*cursor;
   	 HINSTANCE instance;
	       HCURSOR hCursor;
	       instance=NULL;
	       cursor=IDC_ARROW;
	       hCursor=LoadCursor(instance,cursor);
	       SetClassWord(GCW_HCURSOR,(WORD) hCursor);    }
 }


 void TApp::InitMainWindow()
{
  SetMainWindow(new TWndw("Drag&Drop"));
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
